"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = __importDefault(require("path"));
const chalk_1 = __importDefault(require("chalk"));
const yargs_1 = __importDefault(require("yargs"));
const child_process_1 = require("child_process");
const createApp = (args) => {
    return new Promise((resolve, reject) => {
        if (!args.name) {
            console.error(chalk_1.default.red('You must specify a project name'));
            reject();
        }
        if (args.name && args['scripts-version'] && args.template) {
            const proc = child_process_1.spawn(path_1.default.join(__dirname, '..', 'node_modules', '.bin', 'create-react-app'), [
                `--scripts-version=${args['scripts-version']}`,
                `--template=${args.template}`,
                args.name
            ]);
            proc.stdout.on('data', (data) => {
                process.stdout.write(data);
            });
            proc.stderr.on('data', (data) => {
                process.stderr.write(data);
            });
            proc.on('close', () => {
                resolve();
            });
        }
    });
};
const run = () => __awaiter(void 0, void 0, void 0, function* () {
    yargs_1.default
        .scriptName('react-in-a-box')
        .usage('$0 [name]')
        .command({
        command: '$0 [name]',
        describe: 'create a new app',
        builder: (yargs) => yargs.positional('name', {
            required: true,
            describe: 'app name',
            type: 'string'
        }),
        handler: (args) => __awaiter(void 0, void 0, void 0, function* () {
            yield createApp(args);
        })
    })
        .demandCommand(1)
        .option('scripts-version', {
        default: '@next',
        describe: 'react-scripts version',
        type: 'string'
    })
        .option('template', {
        default: 'cra-template@next',
        describe: 'template package',
        type: 'string'
    })
        .help().argv;
});
exports.default = run;
//# sourceMappingURL=app.js.map